--- pbx/pbx_config.dist.c	2006-08-23 20:14:12.644353000 +0200
+++ pbx/pbx_config.c	2006-08-28 16:27:46.019583936 +0200
@@ -782,9 +782,12 @@
 	}
 
 	/* fireout general info */
-	fprintf(output, "[general]\nstatic=%s\nwriteprotect=%s\n\n",
+	fprintf(output, "[general]\nstatic=%s\nwriteprotect=%s\nautofallthrough=%s\nclearglobalvars=%s\npriorityjumping=%s\n\n",
 		static_config ? "yes" : "no",
-		write_protect_config ? "yes" : "no");
+		write_protect_config ? "yes" : "no",
+                autofallthrough_config ? "yes" : "no",
+                clearglobalvars_config ? "yes" : "no",
+		ast_true(ast_variable_retrieve(cfg, "general", "priorityjumping")) ? "yes" : "no");
 
 	if ((v = ast_variable_browse(cfg, "globals"))) {
 		fprintf(output, "[globals]\n");
@@ -850,6 +853,8 @@
 					const char *sep, *cid;
 					char *tempdata = strdup(ast_get_extension_app_data(p));
 					char *s;
+					const char *el = ast_get_extension_label(p);
+					char *label = calloc(1, 128);
 
 					if (!tempdata) { /* XXX error duplicating string ? */
 						incomplete = 1;
@@ -864,11 +869,18 @@
 					} else {
 						sep = cid = "";
 					}
-					fprintf(output, "exten => %s%s%s,%d,%s(%s)\n",
+					if (el) {
+						if (snprintf(label, 127, "(%s)", el) != (strlen(el)+2)) {
+							incomplete = 1;	/* error encountered or label > 125 chars */
+							label = NULL;
+						};
+					};
+					fprintf(output, "exten => %s%s%s,%d%s,%s(%s)\n",
 					    ast_get_extension_name(p), sep, cid,
-					    ast_get_extension_priority(p),
+					    ast_get_extension_priority(p), (label)?label:"",
 					    ast_get_extension_app(p), tempdata);
 					free(tempdata);
+					if (label) free(label);
 				}
 			}
 		}
